<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Insurance extends MY_Controller {

	public function index()
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			redirect('insurance/buy_listing', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function buy_listing()
	{
		save_current_url(base_url() . 'insurance/buy_listing/');
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			if($_POST) {
				$this->session->set_userdata(
					array(
						'member_search_username' => trim($this->input->post('search_username', TRUE)), 
						'member_exclude_downline' => trim($this->input->post('exclude_downline', TRUE)), 
						'member_search_insurance_date' => trim($this->input->post('search_insurance_date', TRUE)), 
						'member_search_start_date' => trim($this->input->post('search_start_date', TRUE)), 
						'member_search_end_date' => trim($this->input->post('search_end_date', TRUE))
						)
				);
				
				$_POST['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_insurance') . ' - ' .$this->lang->line('hf_buy_insurance_history');
			
				$this->load->view('insurance_buy_history', $_POST);
			}
			else {
				$this->session->unset_userdata(array('member_search_username' => '', 'member_exclude_downline' => '', 'member_search_insurance_date' => '', 'member_search_start_date' => '', 'member_search_end_date' => ''));
				
				$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_insurance') . ' - ' .$this->lang->line('hf_buy_insurance_history');
			
				$this->load->view('insurance_buy_history', $data);
			}
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function getbuylist()
    {
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
		
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			$aColumns = array(
								$this->db->dbprefix('member_buy_insurances') . '.transaction_date',
								$this->db->dbprefix('member_buy_insurances') . '.credit_amount',
								$this->db->dbprefix('member_buy_insurances') . '.from_member_username',
								$this->db->dbprefix('member_buy_insurances') . '.status',
							);
			
			$jColumns = $this->db->dbprefix('member_buy_insurances') . '.from_member_id = ' . $this->db->dbprefix('members') . '.member_id';
			
			// DB table to use
			$sTable = 'sw_member_buy_insurances';
			$jTable = 'sw_members';
			//
			
			if($this->session->userdata('member_search_insurance_date') != '') {
				if($this->session->userdata('member_search_insurance_date') == 2) {
					$start_date = strtotime(date('Y-m-d 00:00:00', strtotime($this->session->userdata('member_search_start_date'))));
					$end_date = strtotime(date('Y-m-d 23:59:59', strtotime($this->session->userdata('member_search_end_date'))));
					$where = "(" . $this->db->dbprefix('member_buy_insurances') . ".transaction_date >= '" .  $start_date . "' AND " . $this->db->dbprefix('member_buy_insurances') . ".transaction_date <= '" .  $end_date . "')";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_username') != '') {
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username = ? LIMIT 1", array($this->session->userdata('member_search_username')));
				if($query->num_rows > 0) {
					$row = $query->row();
					$where = $this->db->dbprefix('members') . ".introducer_parent_ref LIKE '%," .  $row->member_id . ",%'";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_exclude_downline') != '') {
				$arr = explode(',', $this->session->userdata('member_exclude_downline'));
				$arr = implode("','", $arr);
				
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username IN('" . $arr . "')");
				if($query->num_rows > 0) {
					$where = '';
					foreach($query->result() as $row) {
						if($where != '') {
							$where .= " AND (" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
						else {
							$where .= "(" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
					}
					
					if($where != '') {
						$where = "(" . $where . ")";
						$this->db->where($where);
					}
				}
			}
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $sSearch);
						// $this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$this->db->join($jTable, $jColumns);
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				$row[] = date('Y-m-d', $aRow['transaction_date']);
				$row[] = number_format($aRow['credit_amount'], 2, '.', '');
				$row[] = $aRow['from_member_username'];
				
				switch($aRow['status']) {
					case 0: $row[] = '<span class="label label-info">' . $this->lang->line('insurance_pending') . '</span>'; break;
					case 1: $row[] = '<span class="label label-success">' . $this->lang->line('insurance_confirmed') . '</span>'; break;
					case 2: $row[] = '<span class="label label-important">' . $this->lang->line('insurance_cancelled') . '</span>'; break;
					default: $row[] = '<span class="label label-info">' . $this->lang->line('insurance_pending') . '</span>'; break;
				}
				
				$output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
	
	public function buy_insurance_export()
	{
		set_time_limit(0);
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			require_once APPPATH."/third_party/php-excel.class.php";
			
			$data[] = array (
								$this->lang->line('insurance_buy_date'),
								$this->lang->line('insurance_amount'),
								$this->lang->line('insurance_from_member'),
								$this->lang->line('insurance_status')
							);
			
			//Get Data
			$aColumns = array(
								$this->db->dbprefix('member_buy_insurances') . '.transaction_date',
								$this->db->dbprefix('member_buy_insurances') . '.credit_amount',
								$this->db->dbprefix('member_buy_insurances') . '.from_member_username',
								$this->db->dbprefix('member_buy_insurances') . '.status',
							);
			
			$jColumns = $this->db->dbprefix('member_buy_insurances') . '.from_member_id = ' . $this->db->dbprefix('members') . '.member_id';
			
			// DB table to use
			$sTable = 'sw_member_buy_insurances';
			$jTable = 'sw_members';
			//
			
			if($this->session->userdata('member_search_insurance_date') != '') {
				if($this->session->userdata('member_search_insurance_date') == 2) {
					$start_date = strtotime(date('Y-m-d 00:00:00', strtotime($this->session->userdata('member_search_start_date'))));
					$end_date = strtotime(date('Y-m-d 23:59:59', strtotime($this->session->userdata('member_search_end_date'))));
					$where = "(" . $this->db->dbprefix('member_buy_insurances') . ".transaction_date >= '" .  $start_date . "' AND " . $this->db->dbprefix('member_buy_insurances') . ".transaction_date <= '" .  $end_date . "')";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_username') != '') {
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username = ? LIMIT 1", array($this->session->userdata('member_search_username')));
				if($query->num_rows > 0) {
					$row = $query->row();
					$where = $this->db->dbprefix('members') . ".introducer_parent_ref LIKE '%," .  $row->member_id . ",%'";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_exclude_downline') != '') {
				$arr = explode(',', $this->session->userdata('member_exclude_downline'));
				$arr = implode("','", $arr);
				
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username IN('" . $arr . "')");
				if($query->num_rows > 0) {
					$where = '';
					foreach($query->result() as $row) {
						if($where != '') {
							$where .= " AND (" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
						else {
							$where .= "(" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
					}
					
					if($where != '') {
						$where = "(" . $where . ")";
						$this->db->where($where);
					}
				}
			}
			
			$this->db->order_by($this->db->dbprefix('member_buy_insurances') . '.transaction_date', 'asc');
			
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$this->db->join($jTable, $jColumns);
			$rResult = $this->db->get($sTable);
			
			foreach($rResult->result_array() as $aRow)
			{
				$status = '';
				switch($aRow['status']) {
					case 0: $status = $this->lang->line('insurance_pending'); break;
					case 1: $status = $this->lang->line('insurance_confirmed'); break;
					case 2: $status = $this->lang->line('insurance_cancelled'); break;
					default: $status = $this->lang->line('insurance_pending'); break;
				}
				
				$data[] = array (
									date('Y-m-d', $aRow['transaction_date']),
									number_format($aRow['credit_amount'], 2, '.', ''),
									$aRow['from_member_username'],
									$status
								);
			}
					
			$xls = new Excel_XML('UTF-8', false, 'Member Buy Insurance List');
			$xls->addArray($data);
			$xls->generateXML('member_buy_insurance_list');
		}
	}
	
	public function claim_listing()
	{
		save_current_url(base_url() . 'insurance/claim_listing/');
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			if($_POST) {
				$this->session->set_userdata(
					array(
						'member_search_username' => trim($this->input->post('search_username', TRUE)), 
						'member_exclude_downline' => trim($this->input->post('exclude_downline', TRUE)), 
						'member_search_insurance_date' => trim($this->input->post('search_insurance_date', TRUE)), 
						'member_search_start_date' => trim($this->input->post('search_start_date', TRUE)), 
						'member_search_end_date' => trim($this->input->post('search_end_date', TRUE)),
						'member_search_insurance_status' => ($this->input->post('search_insurance_status', TRUE) != '') ? implode(',', $this->input->post('search_insurance_status', TRUE)) : ''
						)
				);
				
				$_POST['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_insurance') . ' - ' .$this->lang->line('hf_claim_insurance_history');
			
				$this->load->view('insurance_claim_history', $_POST);
			}
			else {
				$this->session->unset_userdata(array('member_search_username' => '', 'member_exclude_downline' => '', 'member_search_insurance_date' => '', 'member_search_start_date' => '', 'member_search_end_date' => '', 'member_search_insurance_status' => ''));
				
				$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_insurance') . ' - ' .$this->lang->line('hf_claim_insurance_history');
			
				$this->load->view('insurance_claim_history', $data);
			}
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function getclaimlist()
    {
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
		
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			$aColumns = array(
								$this->db->dbprefix('member_claim_insurances') . '.member_transaction_id',
								$this->db->dbprefix('member_claim_insurances') . '.transaction_date',
								$this->db->dbprefix('member_claim_insurances') . '.claim_amount',
								$this->db->dbprefix('member_claim_insurances') . '.from_member_username',
								$this->db->dbprefix('members') . '.casino_username',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_1',
								$this->db->dbprefix('member_claim_insurances') . '.status',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_2',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_3',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_4',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_5',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_6'
							);
							
			$jColumns = $this->db->dbprefix('member_claim_insurances') . '.from_member_id = ' . $this->db->dbprefix('members') . '.member_id';
			
			// DB table to use
			$sTable = 'member_claim_insurances';
			$jTable = 'members';
			//
			
			if($this->session->userdata('member_search_insurance_date') != '') {
				if($this->session->userdata('member_search_insurance_date') == 2) {
					$start_date = strtotime(date('Y-m-d 00:00:00', strtotime($this->session->userdata('member_search_start_date'))));
					$end_date = strtotime(date('Y-m-d 23:59:59', strtotime($this->session->userdata('member_search_end_date'))));
					$where = "(" . $this->db->dbprefix('member_claim_insurances') . ".transaction_date >= '" .  $start_date . "' AND " . $this->db->dbprefix('member_claim_insurances') . ".transaction_date <= '" .  $end_date . "')";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_username') != '') {
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username = ? LIMIT 1", array($this->session->userdata('member_search_username')));
				if($query->num_rows > 0) {
					$row = $query->row();
					$where = $this->db->dbprefix('members') . ".introducer_parent_ref LIKE '%," .  $row->member_id . ",%'";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_exclude_downline') != '') {
				$arr = explode(',', $this->session->userdata('member_exclude_downline'));
				$arr = implode("','", $arr);
				
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username IN('" . $arr . "')");
				if($query->num_rows > 0) {
					$where = '';
					foreach($query->result() as $row) {
						if($where != '') {
							$where .= " AND (" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
						else {
							$where .= "(" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
					}
					
					if($where != '') {
						$where = "(" . $where . ")";
						$this->db->where($where);
					}
				}
			}
			
			if($this->session->userdata('member_search_insurance_status') != '') {
				$where = $this->db->dbprefix('member_claim_insurances') . ".status IN(" .  $this->session->userdata('member_search_insurance_status') . ")";
				$this->db->where($where);
			}
			else {
				$where = $this->db->dbprefix('member_claim_insurances') . ".status = 0";
				$this->db->where($where);
			}
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $sSearch);
						// $this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$this->db->join($jTable, $jColumns, 'left');
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				if($aRow['status'] == 0) {
					$row[] = '<input type="checkbox" name="chkbox[]" value="' . $aRow['member_transaction_id'] . '" onchange="checkOrUncheck(this);" />';
				}
				else {
					$row[] = '';
				}
				
				$row[] = date('Y-m-d H:i:s', $aRow['transaction_date']);
				$row[] = number_format($aRow['claim_amount'], 2, '.', '');
				$row[] = $aRow['from_member_username'];
				$row[] = $aRow['casino_username'];
				
				$claim_slip = '';
				$claim_slip .= ($aRow['claim_slip_1'] != '') ? '<a href="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_1'] . '" target="_blank"><img src="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_1'] . '" border="0" width="36" /></a> &nbsp; ' : '';
				$claim_slip .= ($aRow['claim_slip_2'] != '') ? '<a href="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_2'] . '" target="_blank"><img src="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_2'] . '" border="0" width="36" /></a> &nbsp; ' : '';
				$claim_slip .= ($aRow['claim_slip_3'] != '') ? '<a href="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_3'] . '" target="_blank"><img src="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_3'] . '" border="0" width="36" /></a> &nbsp; ' : '';
				$claim_slip .= ($aRow['claim_slip_4'] != '') ? '<a href="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_4'] . '" target="_blank"><img src="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_4'] . '" border="0" width="36" /></a> &nbsp; ' : '';
				$claim_slip .= ($aRow['claim_slip_5'] != '') ? '<a href="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_5'] . '" target="_blank"><img src="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_5'] . '" border="0" width="36" /></a> &nbsp; ' : '';
				$claim_slip .= ($aRow['claim_slip_6'] != '') ? '<a href="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_6'] . '" target="_blank"><img src="' . str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_6'] . '" border="0" width="36" /></a>' : '';
				$row[] = $claim_slip;
				
				switch($aRow['status']) {
					case 0: $row[] = '<span class="label label-info">' . $this->lang->line('insurance_pending') . '</span>'; break;
					case 1: $row[] = '<span class="label label-success">' . $this->lang->line('insurance_confirmed') . '</span>'; break;
					case 2: $row[] = '<span class="label label-important">' . $this->lang->line('insurance_cancelled') . '</span>'; break;
					default: $row[] = '<span class="label label-info">' . $this->lang->line('insurance_pending') . '</span>'; break;
				}
				
				if($aRow['status'] == 0) {
					$row[] = '<select id="update_status" name="update_status" class="small m-wrap" onchange="update_claim_status(' . $aRow['member_transaction_id'] . ', this.value)">
								<option value="0">' . $this->lang->line('withdrawal_pending_withdrawal') . '</option>
								<option value="1">' . $this->lang->line('withdrawal_approve_withdrawal') . '</option>
								<option value="2">' . $this->lang->line('withdrawal_cancel_withdrawal') . '</option>
							</select>';
				}
				else {
					$row[] = '';
				}
				
				$output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
	
	public function claim_insurance_export()
	{
		set_time_limit(0);
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			require_once APPPATH."/third_party/php-excel.class.php";
			
			$data[] = array (
								$this->lang->line('insurance_claim_date'),
								$this->lang->line('insurance_amount'),
								$this->lang->line('insurance_from_member'),
								$this->lang->line('insurance_game_username'),
								$this->lang->line('insurance_claim_slip') . ' 1',
								$this->lang->line('insurance_claim_slip') . ' 2',
								$this->lang->line('insurance_claim_slip') . ' 3',
								$this->lang->line('insurance_claim_slip') . ' 4',
								$this->lang->line('insurance_claim_slip') . ' 5',
								$this->lang->line('insurance_claim_slip') . ' 6',
								$this->lang->line('insurance_status')
							);
			
			//Get Data
			$aColumns = array(
								$this->db->dbprefix('member_claim_insurances') . '.member_transaction_id',
								$this->db->dbprefix('member_claim_insurances') . '.transaction_date',
								$this->db->dbprefix('member_claim_insurances') . '.claim_amount',
								$this->db->dbprefix('member_claim_insurances') . '.from_member_username',
								$this->db->dbprefix('members') . '.casino_username',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_1',
								$this->db->dbprefix('member_claim_insurances') . '.status',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_2',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_3',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_4',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_5',
								$this->db->dbprefix('member_claim_insurances') . '.claim_slip_6'
							);
							
			$jColumns = $this->db->dbprefix('member_claim_insurances') . '.from_member_id = ' . $this->db->dbprefix('members') . '.member_id';
			
			// DB table to use
			$sTable = 'member_claim_insurances';
			$jTable = 'members';
			//
			
			if($this->session->userdata('member_search_insurance_date') != '') {
				if($this->session->userdata('member_search_insurance_date') == 2) {
					$start_date = strtotime(date('Y-m-d 00:00:00', strtotime($this->session->userdata('member_search_start_date'))));
					$end_date = strtotime(date('Y-m-d 23:59:59', strtotime($this->session->userdata('member_search_end_date'))));
					$where = "(" . $this->db->dbprefix('member_claim_insurances') . ".transaction_date >= '" .  $start_date . "' AND " . $this->db->dbprefix('member_claim_insurances') . ".transaction_date <= '" .  $end_date . "')";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_username') != '') {
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username = ? LIMIT 1", array($this->session->userdata('member_search_username')));
				if($query->num_rows > 0) {
					$row = $query->row();
					$where = $this->db->dbprefix('members') . ".introducer_parent_ref LIKE '%," .  $row->member_id . ",%'";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_exclude_downline') != '') {
				$arr = explode(',', $this->session->userdata('member_exclude_downline'));
				$arr = implode("','", $arr);
				
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username IN('" . $arr . "')");
				if($query->num_rows > 0) {
					$where = '';
					foreach($query->result() as $row) {
						if($where != '') {
							$where .= " AND (" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
						else {
							$where .= "(" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
					}
					
					if($where != '') {
						$where = "(" . $where . ")";
						$this->db->where($where);
					}
				}
			}
			
			if($this->session->userdata('member_search_insurance_status') != '') {
				$where = $this->db->dbprefix('member_claim_insurances') . ".status IN(" .  $this->session->userdata('member_search_insurance_status') . ")";
				$this->db->where($where);
			}
			
			$this->db->order_by( $this->db->dbprefix('member_claim_insurances') . '.transaction_date', 'asc');
			
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$this->db->join($jTable, $jColumns, 'left');
			$rResult = $this->db->get($sTable);
			
			foreach($rResult->result_array() as $aRow)
			{
				$status = '';
				switch($aRow['status']) {
					case 0: $status = $this->lang->line('insurance_pending'); break;
					case 1: $status = $this->lang->line('insurance_confirmed'); break;
					case 2: $status = $this->lang->line('insurance_cancelled'); break;
					default: $status = $this->lang->line('insurance_pending'); break;
				}
				
				$data[] = array (
									date('Y-m-d H:i:s', $aRow['transaction_date']),
									number_format($aRow['claim_amount'], 2, '.', ''),
									$aRow['from_member_username'],
									$aRow['casino_username'],
									($aRow['claim_slip_1'] != '') ? str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_1'] : '-',
									($aRow['claim_slip_2'] != '') ? str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_2'] : '-',
									($aRow['claim_slip_3'] != '') ? str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_3'] : '-',
									($aRow['claim_slip_4'] != '') ? str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_4'] : '-',
									($aRow['claim_slip_5'] != '') ? str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_5'] : '-',
									($aRow['claim_slip_6'] != '') ? str_replace(BO_FOLDER, MEMBER_FOLDER, base_url()) . 'uploads/claims/' . $aRow['claim_slip_6'] : '-',
									$status
								);
			}
					
			$xls = new Excel_XML('UTF-8', false, 'Member Claim Insurance List');
			$xls->addArray($data);
			$xls->generateXML('member_claim_insurance_list');
		}
	}
	
	public function update_claim($transaction_id = NULL, $status = NULL)
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			$this->load->model('user_model');
			
			$rs = $this->user_model->update_claim_status($transaction_id, $status);
				
			redirect('insurance/claim_listing/', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function claim_listing_update()
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			$this->load->model('user_model');
			
			#Recursive deletion
			if(isset($_POST['chkbox'])) {
				for($i=0;$i<sizeof($_POST['chkbox']);$i++) {
					if($_POST['chkbox'][$i] != 'on') {
						$this->user_model->update_claim_status(trim($_POST['chkbox'][$i]), trim($_POST['update_status']));
					}
				}
			}
			
			redirect('insurance/claim_listing/', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}
}

/* End of file insurance.php */
/* Location: ./application/controllers/insurance.php */